import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.text.*;
import java.util.*;

public class Sensor extends Applet 
{ 
    static private boolean isapplet = true;
    static private String arg_ip = null;
    static private int arg_port = 0;
    public Xport gtp = null;
    String reader_ip = null;
    int port = 10001;
    
    public void init()
    {
        gtp = null;
        reader_ip = null;
        port = 10001;
    }
    
    public void start()
    {
        String st = new String("TCP/IP connection status: ");
        setFont(new Font("Dialog",Font.BOLD,16));
        setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0; c.gridy = 0; c.gridwidth = 1; c.gridheight = 1;
        c.anchor = GridBagConstraints.CENTER;
        c.fill = GridBagConstraints.BOTH;
        c.insets =  new Insets(5,5,5,5);
        setBackground(Color.yellow);
        setSize(600,500);
        
        /* Either get the IP address from the HTTP server if we're
         an applet, or from the commandline (if passed). */
        if (isapplet) 
        {
            reader_ip = getCodeBase().getHost();
        }
        else 
        {
            reader_ip = arg_ip;
            // if we were passed an port as an argument
            if (arg_port != 0) 
                port = arg_port;
        }

        /* Open a socket to the Device Server's serial port */
        if (reader_ip != null) 
        {
            if (gtp == null) 
            {
                gtp = new Xport(reader_ip, port);
                if (gtp.connected() == false) 
                {
                    st += "Connection FAILED! ";
                    gtp = null;
                }
            }
        }
        // do we have a valid connection to the XPORT?
        if (gtp == null) 
        {
            st += "Not Connected";
            add((new Label(st)), c);
            return;
        }

        // If we get here we have succefully connected to the XPORT
        st += "Connected";
        add((new Label(st)), c);

        // We can now our our GUI and handle communications to and from the XPORT
        c.gridx = 0; c.gridy = 2; c.gridwidth = 3; c.gridheight = 1;
        c.anchor = GridBagConstraints.WEST;
        add(new Gui(gtp), c);
    }
    
    // On exit we disconect from the Xport
    public void destroy()
    {
        if (gtp != null)
            gtp.disconnect();

        gtp = null;
    }
    
    public void stop() {
    }
    
    public static void main(String[] args) 
    {
        Frame frame = new Frame("Diego Asturias- ECE 491 Fall 2006");
        frame.addWindowListener(
                                new WindowAdapter() 
                                    {
            public void windowClosing(WindowEvent e) 
            {
                System.exit(0);
            }
        });
        if (args.length > 0) 
        {
            arg_ip = args[0];
            if (args.length > 1) {
                try {
                    arg_port = Integer.valueOf(args[1]).intValue();
                }
                catch (NumberFormatException e) {}
            }
        }
        Sensor ap = new Sensor();
        frame.add(ap);
        ap.init();
        isapplet = false;
        ap.start();
        frame.pack();
        frame.show();
    }
}